﻿namespace UltraDayViewControlCurrentDayHeader
{
    using System.Drawing;
    using System.Linq;
    using Infragistics.Win;
    using Infragistics.Win.UltraWinSchedule.DayView;

    internal class CF : IUIElementCreationFilter
    {
        public CF(bool showOwnerHeader)
        {
            this.ShowOwnerHeader = showOwnerHeader;
        }

        public bool ShowOwnerHeader { get; set; }

        public void AfterCreateChildElements(UIElement parent)
        {
            if(this.ShowOwnerHeader == true)
            {
                if(parent is DayHeaderAreaUIElement)
                {
                    var dayHeaderElement = parent.GetDescendant(typeof(DayHeaderUIElement));

                    if(dayHeaderElement != null)
                    {
                        var height = dayHeaderElement.Rect.Height;
                        dayHeaderElement.Parent.ChildElements.Remove(dayHeaderElement);

                        var ownerHeaderElements = dayHeaderElement
                            .Parent
                            .ChildElements
                            .Where(c => c.Rect.X != 0 && c.Rect.Y != 0)
                            .Where(c => c is OwnerHeaderUIElement)
                            .ToList();

                        if(ownerHeaderElements.Count > 0)
                        {
                            foreach(UIElement ownerHeaderElement in ownerHeaderElements)
                            {
                                var rect = ownerHeaderElement.Rect;
                                ownerHeaderElement.Rect = new Rectangle(
                                    rect.X,
                                    rect.Y - height,
                                    rect.Width,
                                    rect.Height + height);
                            }
                        }
                    }
                }
            }
            else
            {
                if(parent is HeadingAreaUIElement)
                {
                    var dayHeaderAreaElement = parent.GetDescendant(typeof(DayHeaderAreaUIElement));
                    var allDayEventAreaElement = parent.GetDescendant(typeof(AllDayEventAreaUIElement));

                    if(dayHeaderAreaElement != null)
                    {
                        var height = dayHeaderAreaElement.Rect.Height;
                        dayHeaderAreaElement.Parent.ChildElements.Remove(dayHeaderAreaElement);

                        if(allDayEventAreaElement != null)
                        {
                            var allDayEventAreaElementRect = allDayEventAreaElement.Rect;
                            allDayEventAreaElement.Rect = new Rectangle(
                                allDayEventAreaElementRect.X,
                                allDayEventAreaElementRect.Y - height,
                                allDayEventAreaElementRect.Width,
                                allDayEventAreaElementRect.Height + height);
                        }
                    }
                }
            }
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }
    }
}
